config/routes.rb
AlteredBeast::Application.routes.draw do
  get '/session' => "sessions#create", :as => 'open_id_complete'

  resources :sites, :moderatorships, :monitorship

  resources :forums do
    resources :topics do
      resources :posts
      resource :monitorship
    end
    resources :posts
  end

  resources :posts do
    get :search, :on => :collection
  end
  resources :users do
    member do
      put :suspend, :make_admin, :unsuspend
      get :settings
      delete :purge
    end
    resources :posts, :only => [:index] do
#      get :monitored, :on => :collection, :shallow => true
    end
  end
  match '/users/:user_id/monitored(.:format)' => 'posts#monitored', :as => 'monitored_posts'

  match '/activate/:activation_code' => 'users#activate', :activation_code => nil, :as => 'activate'
  match '/signup' => 'users#new', :as => 'signup'
  match '/settings' => 'users#settings', :as => 'settings'
  match '/login' => 'sessions#new', :as => 'login'
  match '/logout' => 'sessions#destroy', :as => 'logout'
  match '/itex'  => 'itex#index'
  delete '/monitorship/:forum_id/:topic_id' => 'monitorships#destroy', :as => 'monitorship' 
  match '/monitorship/:forum_id/:topic_id' => 'monitorships#create', :as => 'monitorship' 

  resource  :session

  root :to => 'forums#index'
end

app/models/forum.rb
class Forum < ActiveRecord::Base
  formats_attributes :description

  acts_as_list

  validates_presence_of :name

  belongs_to :site

  has_permalink :name

  attr_readonly :posts_count, :topics_count

  has_many :topics, :order => "#{Topic.table_name}.sticky desc, #{Topic.table_name}.last_updated_at desc", :dependent => :delete_all

  # this is used to see if a forum is "fresh"... we can't use topics because it puts
  # stickies first even if they are not the most recently modified
  has_many :recent_topics, :class_name => 'Topic', :include => [:user],
    :order => "#{Topic.table_name}.last_updated_at DESC",
    :conditions => ["users.state = ?", "active"]
  has_one  :recent_topic,  :class_name => 'Topic', :order => "#{Topic.table_name}.last_updated_at DESC"

  has_many :posts,       :order => "#{Post.table_name}.created_at DESC", :dependent => :delete_all
  has_one  :recent_post, :order => "#{Post.table_name}.created_at DESC", :class_name => 'Post'

  has_many :moderatorships, :dependent => :delete_all
  has_many :moderators, :through => :moderatorships, :source => :user

  scope :public, -> { where(state: 'public') }
  scope :ordered, order(:position)

  def to_param
    permalink
  end

  def monitored_topics(user)
    self.topics.joins(:monitorships).where(:monitorships => {:user_id => user, :active => true})
  end

  def to_s
    name
  end
end

app/controllers/forums_controller.rb
class ForumsController < ApplicationController
  before_filter :admin_required, :except => [:index, :show]
  before_filter :find_forum, :only => [:show, :edit, :update, :destroy]

  # GET /forums
  # GET /forums.xml
  def index
    # reset the page of each forum we have visited when we go back to index
    session[:forums_page] = nil

    @forums = admin? ? current_site.all_forums : current_site.ordered_forums

    respond_to do |format|
      format.html { set_content_type_header } # index.html.erb
      format.xml  { render :xml => @forums }
    end
  end

  # GET /forums/1
  # GET /forums/1.xml
  def show
    (session[:forums] ||= {})[@forum.id] = Time.now.utc
    (session[:forums_page] ||= Hash.new(1))[@forum.id] = current_page if current_page > 1
    @monitored = logged_in? && params[:monitored]
    @topics ||= @forum.topics.paginate :page => current_page
    @monitored_topics ||= logged_in? ? 
        (@forum.monitored_topics(current_user).paginate :page => current_page) :
        nil

    respond_to do |format|
      format.html do # show.html.erb
        set_content_type_header
      end
      format.xml  { render :xml => @forum }
      format.js
    end
  end
  
  # GET /forums/new
  # GET /forums/new.xml
  def new
    @forum = current_site.forums.new

    respond_to do |format|
      format.html {set_content_type_header }# new.html.erb
      format.xml  { render :xml => @forum }
    end
  end

  # GET /forums/1/edit
  def edit
  end

  # POST /forums
  # POST /forums.xml
  def create
    @forum = current_site.forums.build(params[:forum])

    respond_to do |format|
      if @forum.save
        flash[:notice] = I18n.t 'txt.forum_created', :default => 'Forum was successfully created.'
        format.html { redirect_to(@forum) }
        format.xml  { render :xml => @forum, :status => :created, :location => @forum }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @forum.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /forums/1
  # PUT /forums/1.xml
  def update

    respond_to do |format|
      if @forum.update_attributes(params[:forum])
        flash[:notice] = I18n.t 'txt.forum_updated', :default => 'Forum was successfully updated.'
        format.html { redirect_to(@forum) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @forum.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /forums/1
  # DELETE /forums/1.xml
  def destroy
    @forum.destroy

    respond_to do |format|
      format.html { redirect_to(forums_path) }
      format.xml  { head :ok }
    end
  end

  protected

    def find_forum
      @forum = admin? ? current_site.all_forums.find_by_permalink!(params[:id]) : current_site.forums.find_by_permalink!(params[:id])
    end

end

app/helpers/forums_helper.rb
module ForumsHelper
  # used to know if a topic has changed since we read it last
  def recent_topic_activity(topic)
    return false unless logged_in?
    return topic.last_updated_at > ((session[:topics] ||= {})[topic.id] || last_active)
  end 

  # used to know if a forum has changed since we read it last
  def recent_forum_activity(forum)
    return false unless logged_in? && forum.recent_topic
    return forum.recent_topic.last_updated_at > ((session[:forums] ||= {})[forum.id] || last_active)
  end

  def last_active
    session[:last_active] ||= Time.now.utc
  end

  # Ripe for optimization
  def voice_count
    pluralize current_site.topics.to_a.sum { |t| t.voice_count }, 'voice'
  end
end

app/views/forums/_form.html.erb
<%= form.error_messages %>

<div id="forum_name">
  <table class="noborder nopad wide">
    <td>
      <label><%= I18n.t 'txt.views_forums.title', :default => 'Title' %></label><br />
      <%= form.text_field :name, :class => "primary" %>
    </td>
    <td>
     <label><%= I18n.t 'txt.views_forums.state', :default => 'State' %></label><br />
     <%= select(:forum, :state, [['public','public'],['private','private']]) %>
    </td>
    <td style="text-align:right">
      <label><%= I18n.t 'txt.views_forums.position', :default => 'Position' %></label><br />
      <%= form.text_field :position, :size => 5 %>
    </td>
  </table>
</div>

<p id="forum_descripion">
  <label><%= I18n.t 'txt.views_forums.desc', :default => 'Description' %></label><br />
  <%= form.text_area :description, :rows => 7 %>
</p>

app/views/forums/_topics_list.html.erb
<% if topics.total_entries %>
<% if logged_in? %>
<p style="float:right; margin-top:0;"><%= link_to I18n.t('txt.new_topic', :default => 'New topic'), new_forum_topic_path(@forum), :class => "utility" %></p>
<% end %>
<%= will_paginate topics %>
<% end %>

<table class="wide topics">
<tr>
  <th class="la" colspan="2"><%= I18n.t 'txt.topics', :default => 'Topics' %>
  <% if logged_in? %>
    <% if @monitored %>
  ( <%= (link_to((I18n.t 'txt.a', :default => 'all'), forum_path(@forum), :class => "filter", :id => 'filter_link') + ' | ' + (I18n.t 'txt.monitored', :default => 'monitored')).html_safe%> )   
    <% else %>
  ( <%= ((I18n.t 'txt.all', :default => 'all') +' | ' + link_to((I18n.t 'txt.monitored', :default => 'monitored'), forum_path(@forum)+"?monitored=true", :class => "filter", :id => 'filter_link')).html_safe%> ) 
    <% end %>
  <% end %>
  </th>
  <th class="ca"><%= I18n.t 'txt.started', :default => 'Started by' %></th>
  <th style="width: 1%"><%= I18n.t 'txt.posts', :default => 'Posts' %></th>
  <th style="width: 1%"><%= I18n.t 'txt.views', :default => 'Views' %></th>
  <th class="la"><%= I18n.t 'txt.latest_post', :default => 'Latest post' %></th>
</tr>
<% for topic in topics %>
<tr class="entry">
  <td style="padding:5px; width:16px;" class="c1">
    <% 
    icon = "comment"
    color = ""
    if topic.locked?
      icon = "lock"
      post = I18n.t('txt.views_forums.comma_locked_topic', :default => ', this topic is locked.')
      color = "darkgrey"
    end
    %>
    <% if recent_topic_activity(topic) %>
    <%= image_tag "clearbits/#{icon}.gif", :class => "icon green", :title => I18n.t('txt.views_forums.recent_activity', :default => "Recent activity") + "#{post}" %>
    <% else %>
      <%= image_tag "clearbits/#{icon}.gif", :class => "icon grey #{color}", :title => I18n.t('txt.views_forums.no_recent_activity', :default => "No recent activity") + "#{post}" %>
    <% end %>
  </td>
  <td class="c2">
    <%= I18n.t('txt.sticky', :default => ('[sticky]' + '<strong>')).html_safe if topic.sticky? %>
    <%= topic_title_link (topic), :class => "entry-title", :rel => "bookmark" %>
    <%= '</strong>'.html_safe if topic.sticky? %>
    <% if topic.paged? %>
      <small><%= link_to I18n.t('txt.goto_last_page', :default => 'last'), forum_topic_path(@forum, topic, :page => topic.last_page) %></small>
    <% end %>
  </td>
  <td class="ca"><%= topic.user.display_name %></td>
  <td class="ca inv stat"><%= topic.posts.size %></td>
  <td class="ca inv stat"><%= number_with_delimiter(topic.hits) %></td>
  <td class="lp">
    <abbr class="updated" title="<%= topic.recent_post.created_at.xmlschema %>"><%= I18n.t 'txt.post_age', :when => time_ago_in_words(topic.recent_post.created_at), :default => "posted %{when} ago" %></abbr>
    <% if topic.last_user %>
    <%= I18n.t('txt.by_user_html', :user => "<span class=\"author\"><strong class=\"fn\">#{h(topic.recent_post.user.display_name)}</strong></span>", :default => "by %{user}").html_safe %>
    <% end %>
    <span><%= link_to I18n.t('txt.view', :default => 'view'), forum_topic_path(@forum, topic, :page => topic.last_page, :anchor => dom_id(topic.recent_post)) %></span>
  </td>
</tr>
<% end %>
</table>

<%= will_paginate topics %>

<script type='text/javascript'><!--//--><![CDATA[//><!--
if (history && history.replaceState) {
  if ($('filter_link')) $('filter_link').writeAttribute('data-remote');
  if ($$('.pagination')) {
    $$('.pagination a').invoke('writeAttribute','data-remote'); 
    $$('.pagination a').invoke('observe', 'click', function(){
      <%= p = Hash.new
       p.update('page' => params[:page].to_i) if params[:page]
       p.update('monitored' => 'true') if @monitored
       modify_history('pushState', @forum.name, "#{@forum.permalink}.html", p) %>
    });
  }
};
//--><!]]></script>

app/views/forums/edit.html.erb
<div class="crumbs">
  <%= link_to I18n.t('txt.forums', :default => 'Forums'), root_path %> <span class="arrow">&#x2192;</span>
</div>

<h1><%= I18n.t('txt.views_forums.edit', :default => 'Edit Forum') %></h1>

<%= form_for @forum do |f| %>
  <%= render :partial => "form", :object => f %>
  <%= submit_tag I18n.t('txt.save', :default => 'Save Forum') %> <%= I18n.t 'txt.or', :default => 'or' %> <%= link_to(I18n.t('txt.cancel', :default => 'Cancel'), forums_path) %>
<% end %>

app/views/forums/index.html.erb
<% content_for :right do %>

<h5><%= I18n.t 'txt.sidebar.beast_title', :default => 'What is Heterotic Beast?' %></h5>

<p>
  <%= I18n.t('txt.sidebar.beast_desc', :default => "The premier math-enabled forum; small, lightweight and based on <b>Ruby on Rails</b>. Compose equations in <a href='http://golem.ph.utexas.edu/~distler/blog/itex2MMLcommands.html'>itex</a>, and see them rendered in MathML or via MathJax. Draw figures, using the embedded WYSIWYG SVG-editor. Go wild!").html_safe %>
</p>

<% if admin? %>
<h6><%= I18n.t 'txt.admin.title', :default => 'Admin' %></h6>
<p><%= link_to I18n.t('txt.admin.create_new_forum', :default => 'Create New Forum'), new_forum_path, :class => "utility" %></p>
<% end %>

<% end %>

<h1 style="margin-top:0;"><%= I18n.t 'txt.forums', :default => 'Forums' %></h1>
<p class="subtitle">
<%= feed_icon_tag I18n.t('txt.recent_posts', :default => "Recent Posts"), posts_path(:format => 'atom') %>
<%= I18n.t 'txt.count_topics', :count => current_site.topics.size, :num => number_with_delimiter(current_site.topics.size) %>,
<%= I18n.t 'txt.count_posts',  :count => current_site.posts.size,  :num => number_with_delimiter(current_site.posts.size) %>
</p>

<table class="wide forums">
  <tr>
    <th class="la" style="width: 70%" colspan="3"><%= I18n.t 'txt.forum', :default => 'Forum' %></th>
    <th class="la" style="width: 30%" colspan="1"><%= I18n.t 'txt.latest_post', :default => 'Last Post' %></th>
  </tr>
<% for forum in @forums do %>  
  <tr class="forum" id="forum_<%= forum.id %>_row">
    <td class="vat c1">
    
      <% if recent_forum_activity(forum) %>
      <%= image_tag "clearbits/comment.gif", :class => "icon green", :title => I18n.t('txt.recent_activity', :default => 'Recent activity') %>
      <% else %>
      <%= image_tag "clearbits/comment.gif", :class => "icon grey", :title => I18n.t('txt.no_recent_activity', :default => 'No recent activity') %>
      <% end %>
    </td>
    <td class="c2 vat">
      <%= link_to forum.name, forum_path(forum), :class => "title" %>
      <div class="posts">
        <%= I18n.t 'txt.count_topics', :count => forum.topics.size, :num => number_with_delimiter(forum.topics.size) %>,
        <%= I18n.t 'txt.count_posts', :count => forum.posts.size, :num => number_with_delimiter(forum.posts.size) %>
      </div>
      <%= forum.description_html.html_safe %>
    </td>
    <td class="c3">
      <%= link_to I18n.t('txt.edit', :default => 'Edit'), edit_forum_path(forum), :class => "tiny", :rel => "directory", :style => "float:right" if admin? %>
    </td>

    <td class="inv lp">
      <% if forum.recent_post %>
        <%= I18n.t 'txt.post_age', :when => time_ago_in_words(forum.recent_post.created_at), :default => "posted %{when} ago" %><br />
        <strong><%= I18n.t 'txt.by_user', :default => 'by %{user}', :user => forum.recent_post.user.display_name %></strong>
        <span>(<%= link_to I18n.t('txt.view', :default => 'view'), forum_topic_path(forum, forum.recent_post.topic, :page => forum.recent_post.topic.last_page, :anchor => dom_id(forum.recent_post)) %>)</span>
      <% end %>
    </td>
  </tr>
<% end %>
</table>

<p>
  <%= link_to I18n.t('txt.show_recent_posts', :default => 'Show recent posts'), posts_path %>
</p>

<% if (online_users = current_site.users_online).length > 0 %>
<div class="stats">
  <div class="users">
    <%= I18n.t('txt.users_online', :default => 'Users online') %>: <%= (online_users.map { |u| link_to content_tag(:strong, u.display_name), user_path(u) } * ", ").html_safe %><br />
  </div>
</div>
<% end %>

app/views/forums/new.html.erb
<div class="crumbs">
  <%= link_to I18n.t('txt.forums', :default => 'Forums'), root_path %> <span class="arrow">&#x2192;</span>
</div>

<h1><%= I18n.t('txt.views_forums.new', :default => 'New Forum') %></h1>

<%= form_for @forum do |f| %>
  <%= render :partial => "form", :object => f %>
  <%= submit_tag I18n.t('txt.create', :default =>'Create') %> <%= I18n.t 'txt.or', :default => 'or' %> <%= link_to(I18n.t('txt.cancel', :default => 'Cancel'), forums_path) %>
<% end %>

app/views/forums/show.html.erb
<% content_for :right do %>

<% unless @forum.description.blank? %>
<%= @forum.description_html.html_safe %>
<hr />
<% end %>

<h5 style="margin-bottom:1.0em;"><%= I18n.t 'txt.moderator', :count => @forum.moderators.size, :default => 'Moderator' %></h5>

<% unless @forum.moderators.empty? %>
<ul class="flat" style="margin-top:1em;">
<% @forum.moderators.each do |user| %>
  <li><%= link_to user.display_name || user.login, user %></li>
<% end %>
</ul>
<% else %>
<p><%= I18n.t 'txt.views_forums.unmoderated_html', :default => 'This forum is currently unmoderated.<br />Please always be courteous.'.html_safe %></p>
<% end %>

<% end %>

<% @page_title = @forum.name %>

<div class="crumbs">
<%= link_to I18n.t('txt.forums', :default => 'Forums'), root_path %> <span class="arrow">&#x2192;</span>
</div>
<h1 style="margin-top:0.5em"><%= @forum.name %></h1>

<p class="subtitle">
  <%= feed_icon_tag @forum.name, forum_posts_path(@forum, :format => :atom) %> 
  <%= I18n.t 'txt.count_topics', :count => @forum.topics.size, :num => number_with_delimiter(@forum.topics.size) %>,
  <%= I18n.t 'txt.count_posts', :count => @forum.posts.size, :num => number_with_delimiter(@forum.posts.size) %>
</p>

<div id="topics_list">
<%= if @monitored
      render(:partial => 'topics_list', :object => @monitored_topics, :as => :topics)
    else
      render(:partial => 'topics_list', :object => @topics, :as => :topics)
    end
%>
</div>

<% if logged_in? %>
  <p><%= link_to I18n.t('txt.new_topic', :default => 'New topic'), new_forum_topic_path(@forum), :class => "utility" %></p>
<% end%>

<script type='text/javascript'><!--//--><![CDATA[//><!--
if (history  && history.replaceState && $$('.pagination')) {
  Event.observe(window, 'popstate', function(event){
    new Ajax.Request("<%= @forum.permalink %>", {method: 'get', parameters: event.state})
  });
};
//--><!]]></script>

app/views/forums/show.js.erb
<% if @monitored %>
  $('topics_list').update("<%= escape_javascript(render(:partial => 'topics_list', :object => @monitored_topics, :as => :topics))%>");
<% else %>
  $('topics_list').update("<%= escape_javascript(render(:partial => 'topics_list', :object => @topics, :as => :topics))%>");
<% end %>
<%= p = Hash.new
   p.update('page' => params[:page].to_i) if params[:page]
   p.update('monitored' => 'true') if @monitored
   modify_history('replaceState', @forum.name, "#{@forum.permalink}.html", p) %>